@echo off

rem ********************************************************************************
rem *
rem * Update-Network-Files.BAT
rem *
rem * This file reads the user's network environment variables, set in netvars.bat
rem * and updates the appropriate network files on the user's diskette.
rem *
rem * This batch file is called by the Customize-netvars.BAT.
rem *
rem ********************************************************************************

rem ********************************************************************************
rem * Run to setup environment variables
rem ********************************************************************************
call a:\netvars.bat

rem ********************************************************************************
rem * Update the values in Network.ini
rem ********************************************************************************
..\utils\win32\clini a:\net\network.ini /S:network /I:computername /V:%DPLY_NAME%


rem ********************************************************************************
rem * Update the values in protocol.ini :  Broadcom
rem ********************************************************************************
..\utils\win32\clini a:\bcom\protocol.ini /S:NTS$NTSTS /I:NBNSAddr /V:[%SRV_IP%]
..\utils\win32\clini a:\bcom\protocol.ini /S:NTS$NTSTS /I:NBDGAddr /V:[%SRV_IP%]

FOR %%i in (y Y) do if %USE_DHCP% == %%i goto BDHCP
..\utils\win32\clini a:\bcom\protocol.ini /S:NTS$NTSTS /I:BootPFlag /V:Never
..\utils\win32\clini a:\bcom\protocol.ini /S:NTS$NTSTS /I:GatewayAddr /V:[%SRV_GATE%]
..\utils\win32\clini a:\bcom\protocol.ini /S:NTS$NTSTS /I:NetSubNetMask /V:[%SRV_MASK%]
..\utils\win32\clini a:\bcom\protocol.ini /S:NTS$NTSTS /I:IPAddr /V:[%DPLY_IP%]
goto E100X

:BDHCP
..\utils\win32\clini a:\bcom\protocol.ini /S:NTS$NTSTS /I:BootPFlag /V:DHCP
..\utils\win32\clini a:\bcom\protocol.ini /S:NTS$NTSTS /I:GatewayAddr /V:[0.0.0.0]
..\utils\win32\clini a:\bcom\protocol.ini /S:NTS$NTSTS /I:NetSubNetMask /V:[0.0.0.0]
..\utils\win32\clini a:\bcom\protocol.ini /S:NTS$NTSTS /I:IPAddr /V:[0.0.0.0]


:E100X
rem ********************************************************************************
rem * Update the values in protocol.ini :  IBM Gigabit
rem ********************************************************************************
..\utils\win32\clini a:\e1000\protocol.ini /S:NTS$NTSTS /I:NBNSAddr /V:[%SRV_IP%]
..\utils\win32\clini a:\e1000\protocol.ini /S:NTS$NTSTS /I:NBDGAddr /V:[%SRV_IP%]

FOR %%i in (y Y) do if %USE_DHCP% == %%i goto EXDHCP
..\utils\win32\clini a:\e1000\protocol.ini /S:NTS$NTSTS /I:BootPFlag /V:Never
..\utils\win32\clini a:\e1000\protocol.ini /S:NTS$NTSTS /I:GatewayAddr /V:[%SRV_GATE%]
..\utils\win32\clini a:\e1000\protocol.ini /S:NTS$NTSTS /I:NetSubNetMask /V:[%SRV_MASK%]
..\utils\win32\clini a:\e1000\protocol.ini /S:NTS$NTSTS /I:IPAddr /V:[%DPLY_IP%]

goto END

:EXDHCP
..\utils\win32\clini a:\e1000\protocol.ini /S:NTS$NTSTS /I:BootPFlag /V:DHCP
..\utils\win32\clini a:\e1000\protocol.ini /S:NTS$NTSTS /I:GatewayAddr /V:[0.0.0.0]
..\utils\win32\clini a:\e1000\protocol.ini /S:NTS$NTSTS /I:NetSubNetMask /V:[0.0.0.0]
..\utils\win32\clini a:\e1000\protocol.ini /S:NTS$NTSTS /I:IPAddr /V:[0.0.0.0]


:END


