@echo off

rem ********************************************************************************
rem *
rem * CUSTUNAT.BAT
rem *
rem * This file controls the end user customizations for the Microsoft(R) answer
rem * file for the ServerGuide Scripting Toolkit.
rem *
rem * This batch file is called by the custunat.
rem *
rem ********************************************************************************


rem ********************************************************************************
rem * Change to the target path
rem ********************************************************************************
%NOSDRV%
cd \%WRK_DIR%


rem ********************************************************************************
rem * Obtain the Serial Number from the HWDetect.ini file.
rem ********************************************************************************
CLIni HWDetect.ini /S:System /I:Serial_Number /E:SerNum
if errorlevel 1 goto CLERROR
Call CLIniSet.bat


rem ********************************************************************************
rem * Branch on Serial Number.
rem ********************************************************************************
if "%SerNum%"=="0123456" goto COMP1
if "%SerNum%"=="1234567" goto COMP2
echo There are no %ANS_FILE% customizations for this system.
goto END


:COMP1
rem ********************************************************************************
rem * Set the computer name and product id information for Comp1.
rem ********************************************************************************
CLIni %ANS_FILE% /S:UserData /I:ComputerName /V:\"TKComputer1\"
CLIni %ANS_FILE% /S:UserData /I:ProductID /V:\"11111-11111-11111-11111-11111\"
goto END


:COMP2
rem ********************************************************************************
rem * Set the computer name and product id information for Comp2.
rem ********************************************************************************
CLIni %ANS_FILE% /S:UserData /I:ComputerName /V:\"TKComputer2\"
CLIni %ANS_FILE% /S:UserData /I:ProductID /V:\"22222-22222-22222-22222-22222\"
goto END


:CLERROR
rem ********************************************************************************
rem * An error occurred while reading the Serial Number from the HWDetect.ini file.
rem ********************************************************************************
echo An error occurred while reading the Serial Number from the HWDetect.ini file.
echo.
goto ERROR


:ERROR
rem ********************************************************************************
rem * Hit an error in this batch file.
rem ********************************************************************************
echo Encountered an error and stopped processing in "custunat.bat".
savestat.exe /set2=251 > nul
goto END


:END
rem ********************************************************************************
rem * Clean up and exit.
rem ********************************************************************************
set SerNum=
